-- The interesting procedure is genPoincare
-- To get the (conjectured) PB-series for
-- the module of m'th order differential operators
-- on a generic n-arrangement with r hyperplanes, do
-- genPoincare(n,r,m)
-- In the result, t denotes homological degree, b ordinary degree



-------------------------------------------
-- This function computes the differential 
-- operators of order k 
-- on an affine variety defined by 
-- a homogeneous ideal I in a polynomial ring
---------------------------------------------
diffOpsJSh = method()
diffOpsJSh (RingElement, ZZ) := 
(f, k) -> (diffOpsJSh(ideal f, k))
diffOpsJSh (Ideal, ZZ) := 
(I, k) -> (
     R := ring I;
     F := gens I;
     xbasis := matrix {
	  flatten apply( toList(0..0), 
	       i -> (
	       	    (entries symmetricPower(
			      k-i, vars R))#0 
		    ) 
	       )
     };
     smallxbasis := matrix {
	  flatten apply( toList(0..k-2), 
	       i -> (
	       	    (entries symmetricPower(
			      k-1-i, vars R))#0 
		    )
	       )     
	  };
     temp := transpose diff(
	  transpose xbasis, 
	  F | flatten (
	       (transpose smallxbasis)*F) 
	  );
     addon := directSum toList(
	  rank target temp:matrix{{F}});
     full := temp | addon;
     syzy := (syz full)^{0..rank source temp - 1}; 
     syzy2 = gens gb (syzy % 
	  (directSum toList(
		    rank target syzy:matrix{{F}})
	       )
	  );
     use R;
     hashTable {
	  FullMatrix => full, 
	  TempMatrix => temp,
	  XbMatrix => xbasis, 
	  SmallXbMatrix => smallxbasis,
	  ModuloPolyGens => syzy2, 
	  PolyGens => syzy
	  }
     )


KK=ZZ/31991

Rn = method()
Rn (ZZ) := (n) -> (
     KK[x_1..x_n]
     )

randProd = method()
randProd(ZZ,ZZ) := (n,r) -> (
     S := Rn(n);
     product toList apply(1..r, i -> (random(S^1,S^{-1}))_(0,0))
     )
     
genHypBetti =  method()
genHypBetti (ZZ,ZZ,ZZ) := (n,r,j) -> (
     f := randProd(n,r);
     betti res image mingens image matrix entries (diffOpsJSh( f,j))#PolyGens
     )
     
genHypBettiAll = method()
genHypBettiAll (ZZ,ZZ) := (n,r) -> (
     j = 1;
     while j <= r - n do (
	  << betti res image mingens  image matrix entries (diffOpsJSh( f,j))#PolyGens << endl << endl;
	  j = j+1;
	  )
     )
	
     	
	
genPoincare = method()
genPoincare (ZZ,ZZ,ZZ) := (n,r,j) -> (
     f := randProd(n,r);
     reso := res image mingens image matrix entries (diffOpsJSh( f,j))#PolyGens;     
     W := ZZ[b,t];
     PN := poincareN reso;
     mymap := map(W, ring PN, {t,b});
     mymap PN
     )    	      	    	     	       	
	           
     